#!/bin/sh
# Title: 
#   Simple System Information
# 
# Description:
#   Displays system information such as hard drive usage, RAM, CPU, GPU, versioning information in a user friendly way.
#
# Authors:
#    Scott Prader (scott@garson.org)
#    Jonathan Ben-Joseph (jbenjos@fau.edu)
#
# Copyright (c) 2008 Contributors above.
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.


echo "cpu:[`awk -F":" '/model name/ { print $2 }' /proc/cpuinfo | uniq` ] mem:[ `free -m | awk '/Mem/ { print ($3-$6-$7) "MB used of " $2 "MB total (" ($6+$7) "MB cache)" }'` ] hdd:[ `df -Th | awk '/\/$/ { print $2 " with " $3 "B (" $5 "B free)"}'` ] gpu:[`lspci | awk -F":" '/VGA/ { print $3 }'` ] distro:[ `lsb_release -d | awk -F":" '/Description/ { print substr($2,2) }'` ] kernel:[ `awk '{ print $3 }' /proc/version` ]"
