#!/bin/bash
# 
# Title:
#   A Selection of Bash Prompts [PRE-ALPHA]
#
# Description:
#    This script changes your Bash prompts based on a selection of different themes.
# 
# Author: 
#   Jonathan Ben-Joseph <jbenjos@fau.edu>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.

#TODO: Better way to add color to prompt.

function set-prompt 
{
	#REP=$((`grep -n "bash-prompts.sh" ~/.bashrc | awk -F":" '{ print $1 }'` + 1))
	#if [[ $REP -ne 1 ]]; then
	#     echo $REP
	     #sed \'${REP}i PS1=\"${1}\"\' ~/.bashrc
	#fi
	echo >> ~/.bashrc
    echo "# Custom Bash prompt (automatically added by bash-prompts.sh)" >> ~/.bashrc
    echo "PS1=\"${1}\"" >> ~/.bashrc
}  

echo "A Small Selection of Bash Prompts"
echo
echo "1. [user@hostname directory] "
echo -e "1R. [user@hostname \e[31;1mdirectory\e[0m] "
echo -e "1B. [user@hostname \e[34;1mdirectory\e[0m] "
echo -e "1C. [user@hostname \e[36;1mdirectory\e[0m] "
echo "2. [ directory ] "
echo -e "2R. [ \e[31;1mdirectory\e[0m ]"
echo -e "2B. [ \e[34;1mdirectory\e[0m ]"
echo -e "2C. [ \e[36;1mdirectory\e[0m ]"
echo "3. directory> "
echo -e "3R. \e[31;1mdirectory\e[0m>"
echo -e "3B. \e[34;1mdirectory\e[0m>"
echo -e "3C. \e[36;1mdirectory\e[0m>"
echo "4. [=] "
echo "Q. Quit without doing anything"
echo
echo "Please select a Bash prompt to use by entering the menu option number."
read -p "Enter option: " IN

if [[ "$IN" =~ ^[qQ] ]]; then
    echo; echo "Quitting installer..."; echo
    exit 0
fi

case "$IN" in
   '1')
      set-prompt "[\u@\h \w] "
   ;;
   '1R')
      set-prompt "[\u@\h \[\e[31;1m\]\w\[\e[0m\]] "
   ;;
   '1B')
      set-prompt "[\u@\h \[\e[34;1m\]\w\[\e[0m\]] "
   ;;
   '1C')
      set-prompt "[\u@\h \[\e[36;1m\]\w\[\e[0m\]] "
   ;;
   '2')
      set-prompt "[ \w ] "
   ;;
   '2R')
      set-prompt "[ \[\e[31;1m\]\w\[\e[0m\] ] "
   ;;
   '2B')
      set-prompt "[ \[\e[34;1m\]\w\[\e[0m\] ] "
   ;;
   '2C')
      set-prompt "[ \[\e[36;1m\]\w\[\e[0m\] ] "
   ;;
   '3')
      set-prompt "\w> "
   ;;
   '3R')
      set-prompt "\[\e[31;1m\]\w\[\e[0m\]> "
   ;;
   '3B')
      set-prompt "\[\e[34;1m\]\w\[\e[0m\]> "
   ;;
   '3C')
      set-prompt "\[\e[36;1m\]\w\[\e[0m\]> "
   ;;
   '4')
      set-prompt "[=] "
   ;;
esac

echo; echo "Prompt successfully changed."
echo "Reload your configuration [ . ~/.bashrc ] or restart your session to see the changes."; echo
