#!/bin/bash
# 
# Title:
#   Sudo without Password
#
# Description:
#    This simple bash script removes the need to type a password when using sudo.
# 
# Author: 
#   Jonathan Ben-Joseph <jbenjos@fau.edu>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.

if [[ $EUID -ne 0 ]]; then
   echo "Error: This script must be run as a superuser. Did you prefix with sudo or are you root?"
   echo 
   exit 1
fi

echo "DANGER!!"
echo "You are about to remove the password for sudo. This may cause all kinds of nasty."
echo "You don't even know the start of it."
echo "You are warned. There is no turning back after this. Your life may be changed forever."
read -p "Are you sure you want to do this? Pick wisely. [y/N] " IN
echo

if [[ "$IN" =~ ^[yY] ]]; then
   sed -i 's/%admin ALL=(ALL) ALL/%admin ALL=NOPASSWD: ALL/' /etc/sudoers
   echo "Finished. Welcome to the rabbit hole."
else
   echo "Coward."
fi
