#! /usr/bin/env python

# Author KIAaze http://www.ohloh.net/accounts/KIAaze
#
# This script is released under The GNU General Public License version 3
# http://www.gnu.org/licenses/gpl-3.0-standalone.html
# You may modify and distribute this script as you wish, but please give credit 

# A script to add #ifndef/#define/#endif headers to files

import re
import sys
import os
import shutil
import getopt
import glob

def usage():
	print 'A script to add #ifndef/#define/#endif headers to files'
	print 'Usage: '+os.path.basename(sys.argv[0])+'[OPTION]... [FILE]...'
	print '-h, --help: Display this help message.'
	print '-a, --all: Process all .h files.'

def addheader(filename):
    header=filename.replace('./','')
    header=header.upper()
    header=header.replace('.','_')
    header='_'+header+'_'
    #print filename
    #print header

    in_file=open(filename,'r')
    out_file=open("tmp",'w')

    print "Adding header"
    out_file.write('#ifndef '+header+'\n')
    out_file.write('#define '+header+'\n')
    out_file.write('\n')

    print "Copying file contents"
    for line in in_file:
	    out_file.write(line)

    print "Adding footer"
    out_file.write('\n')
    out_file.write('#endif\n')

    in_file.close()
    out_file.close()

    print "Saving original file as "+filename+'.bak'
    shutil.move(filename,filename+'.bak')
    print "Overwriting original file with new file"
    shutil.move("tmp",filename)

def addheader_all():
    headers=glob.glob('*.h')
    for h in headers:
	print h
	addheader(h)

def main():
    if len(sys.argv)==1:
	    usage()
	    sys.exit()
    try:
        opts, args = getopt.getopt(sys.argv[1:], "ha", ["help", "all"])
    except getopt.GetoptError, err:
        # print help information and exit:
        print str(err) # will print something like "option -a not recognized"
        usage()
        sys.exit(2)
    for o, a in opts:
        if o in ("-a", "--all"):
            addheader_all()
            sys.exit() #exit to avoid processing files twice in case of additional args
        elif o in ("-h", "--help"):
            usage()
            sys.exit()
        else:
            assert False, "unhandled option"
    for a in args:
	addheader(a)

if __name__ == "__main__":
    main()

#filename=sys.argv[1]
#addheader(filename)
