#!/bin/bash

# Author KIAaze http://www.ohloh.net/accounts/KIAaze
#
# This script is released under The GNU General Public License version 3
# http://www.gnu.org/licenses/gpl-3.0-standalone.html
# You may modify and distribute this script as you wish, but please give credit 

# A script to list installed packages by size. Useful when in a virtual terminal without access to synaptic, among other things.

if [ $# -ne 1 ]
then
        echo "usage : $0 <Format=0/1/2/3>"
	echo "Format 0: <size> <package>"
	echo "Format 1: <package> <size>"
	echo "Format 2: <package> <size> install ok installed"
	echo "Format 3: Package:<package> State:installed Uncompressed Size:<size>"
	echo "Note: Format 3 is Very slow and seems to only list packages installed with aptitude"
        exit 0
fi

#Format: <size> <package>
if [ $1 -eq 0 ]
then
	dpkg-query -W --showformat='${Installed-Size;10}\t${Package}\n' | sort -k1,1n
fi

#Format: <package>  <size>
if [ $1 -eq 1 ]
then
	dpkg-query --show --showformat='${Package;-50}\t${Installed-Size}\n' | sort -k 2 -n
fi

#Format: <package>  <size> install ok installed
if [ $1 -eq 2 ]
then
	dpkg-query --show --showformat='${Package;-50}\t${Installed-Size} ${Status}\n' | sort -k 2 -n |grep -v deinstall
fi

#Format: Package:<package> State:installed Uncompressed Size:<size>
#Note 1: Very slow
#Note 2: Seems to only list packages installed with aptitude
if [ $1 -eq 3 ]
then
	aptitude show '~n.*' | awk '\
	/^Package:/ {p = $0};\
	/^State:/ {s = $0};\
	/^Uncompressed Size:/ {print p " " s " " $0};\
	' | grep 'State: installed' | sed 's/: /:/g' | sort -t: -n -k4
fi
