#! /bin/bash
# Author KIAaze http://www.ohloh.net/accounts/KIAaze
#
# This script is released under The GNU General Public License version 3
# http://www.gnu.org/licenses/gpl-3.0-standalone.html
# You may modify and distribute this script as you wish, but please give credit 

# convert images from any format to any other format (uses ImageMagick's "convert" ;) )

# Check if all parameters are present
# If no, exit
if [ $# -ne 2 ]
then
	echo
	echo "convert images from any format to any other format (uses ImageMagick's \"convert\" ;) )"
	echo "usage :"
	echo "`basename $0` oldext newext"
	echo "This shellscript will convert all images *oldext to *newext"
	echo "If *newext already exists, it will ask before overwriting."
	echo "The dot should be included in the arguments (i.e.: \"`basename $0` .png .jpg\")"
        echo
        exit 0
fi

oldext=$1
newext=$2

files=`find . -name "*$oldext"`

for f in $files;
do
	dir=`dirname $f`
	base=`basename $f $oldext`
	echo "$f->$dir/$base$newext"
	if test -e $dir/$base$newext
	then
		echo "$dir/$base$newext already exists. Do you want to overwrite it? (y=yes/n=no/q=quit)"
		read ans
		case $ans in
		y|Y|yes) convert $f $dir/$base$newext;;
		q) exit 0;;
		esac
	else
		convert $f $dir/$base$newext
	fi
done
